SystemOrganization addCategory: #'Pier-TabbedPagesWidgets'!

PRChildrenWidget subclass: #PRTaggedPagesWidget
	instanceVariableNames: 'target tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-TabbedPagesWidgets'!

!PRTaggedPagesWidget commentStamp: 'kph 10/20/2007 16:04' prior: 0!
Displays those children of a given target (or the current page) which have the selected tag.

We do not inlcude the current page in that list.
If there are none, then display nothing unlike the standard widget which defaults to displaying siblings in this situation.!

PRTaggedPagesWidget subclass: #PRTabbedPagesWidget
	instanceVariableNames: 'tabs uid items selected beenHere selectedPrior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-TabbedPagesWidgets'!

!PRTabbedPagesWidget class methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 19:44'!
descriptionHighlight
	^ nil! !

!PRTabbedPagesWidget class methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 19:44'!
descriptionHighlightPath
	^ nil! !

!PRTabbedPagesWidget class methodsFor: 'as yet unclassified' stamp: 'kph 11/10/2007 04:22'!
label

^ 'Tabbed Pages'! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 21:02'!
children
	  items := nil.
	^ self items gather: [ :each | self context componentsOf: each ]! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 4/25/2008 10:36'!
childrenDo: aBlock
	"added test to avoid recursive pattern"
	super childrenDo: [:ea | ea ifNotNil: [(ea ~= self) ifTrue: [ aBlock value: ea ]]]! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 16:48'!
component

	^ PRDefaultView on: (self context copy setStructure: self selected)! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 18:36'!
cssClass
	^ 'kalsey'! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 17:02'!
findIndex: aStructure ifAbsent: aBlock
	| index |
	index := self items findFirst: [ :each | each value = aStructure ].
	index isZero ifTrue: [ aBlock value ].
	^ index! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 16:53'!
initialize

	super initialize.
	beenHere := false.
	tabs := SUTabPanel new.
	
! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/12/2007 02:53'!
items
	"locally cache"
	
	^ items ifNil: [ items := super items asSortedCollection: [ :a :b | a name <= b name ] ]! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 16:23'!
renderContentOn: html
	uid := html nextId.
	html div
		class: self cssClass;
		with: [ self renderNavigationOn: html ]! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 19:49'!
renderNavigationOn: html
	self dropdownList
		ifTrue: [ self renderSelect: self items on: html ]
		ifFalse: [ self renderTabsOn: html. ].
	self renderPanelOn: html! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 20:25'!
renderPanelOn: html
	html div
		id: (self uid: 'body' at: 0);
		class: 'navigation-content';
		with: [
			self updatePanelOn: html.
		]! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 20:15'!
renderSelect: aCollection on: html
	| id |
	html form: [
		html select
			id: (id := html nextId);
			list: aCollection;
			selected: self selected;
			labels: [ :each | self labelFor: each ];
			onChange: (html evaluator
						triggerFormElement: id;
						callback: [ :script | self scriptSelectedOn: script ];
						return: false);
			callback: [ :each |  self selected: each ] ]! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/12/2007 02:53'!
renderTabsOn: html
	| active |
	html unorderedList class: 'navigation-options'; with: [
		self items withIndexDo: [ :each :index |
			active := self selected = each.
			html listItem
				id: (self uid: 'head' at: index);
				class: (active ifTrue: [ 'option-selected' ]);
				with: [
					html anchor
						onClick: (html evaluator
							callback: [ :script | self selected: each. self scriptTabSelectedOn: script ];
							return: false);
						"callback: [ self selected: each ];"
						with: (self labelFor: each) ] ] ]! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 20:29'!
scriptSelectedOn: aScript
 	 
	aScript element
		id: (self uid: 'body' at: 0);
		render: [ :h |  self updatePanelOn: h ].! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 20:30'!
scriptTabSelectedOn: aScript
	 aScript element
		id: (self uid: 'head' at: (self
			findIndex: self selectedPrior
			ifAbsent: [ ]));
		removeClassName: 'option-selected'.
		
	aScript element
		id: (self uid: 'head' at: (self
			findIndex: self selected
			ifAbsent: [ ^ self ]));
		addClassName: 'option-selected'.
	 
	self scriptSelectedOn: aScript! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 20:02'!
selected

	^ selected ifNil: [ selected := self items firstOrNil ]! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 19:56'!
selected: aStructure
	selectedPrior := selected.
	selected := aStructure ! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 19:56'!
selectedPrior
	^ selectedPrior  ! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 16:49'!
uid: aString at: anInteger
	^ uid , '_' , aString , '_' , anInteger asString! !

!PRTabbedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 20:24'!
updatePanelOn: html 
 
	beenHere ifTrue: [ ^ self ].
	beenHere := true.
	[ html render: self component ]
		ensure: [ beenHere := false ]! !

!PRTaggedPagesWidget class methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 23:49'!
availableTags
	| allTags  |
	
	allTags := Set new.

	((PRCurrentContext value kernel root) enumerator all) do: [ :each | allTags addAll: each tags ].
 
	^ allTags asSortedCollection
 ! !

!PRTaggedPagesWidget class methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 23:36'!
context
 ^(PRContext new setKernel: (PRKernel instances anyOne))  ! !

!PRTaggedPagesWidget class methodsFor: 'as yet unclassified' stamp: 'kph 9/14/2007 00:34'!
defaultMaxItems
	^ 200! !

!PRTaggedPagesWidget class methodsFor: 'as yet unclassified' stamp: 'kph 9/14/2007 00:37'!
descriptionBelow
	^ PRStructureDescription new
		comment: 'The root from which to find tagged pages';
		selectorAccessor: #target;
		label: 'Below';
		priority: 50;
		beSetting;
		yourself! !

!PRTaggedPagesWidget class methodsFor: 'as yet unclassified' stamp: 'kph 11/10/2007 05:10'!
descriptionTag
	^ MASingleOptionDescription new
		selectorAccessor: #tag;
		label: 'Tag';
		priority: 210;
		default: nil;
		options: [self availableTags ] asDynamicObject;
		comment: 'Show items with this tag';
 		reference: MAStringDescription new;
		beSorted;
		beSetting;
		"beExtensible;"
		yourself! !

!PRTaggedPagesWidget class methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 22:14'!
label

^ 'Tagged Pages'! !

!PRTaggedPagesWidget methodsFor: 'accessing' stamp: 'kph 10/20/2007 16:31'!
childrenOf: aStructure
	^ (self context enumeratorFor: aStructure) reject: [ :each | self isFiltered: each ]! !

!PRTaggedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 9/14/2007 00:12'!
isFiltered: aStructure

	^	(self tag ifNil: [ false ] ifNotNil: [ (aStructure tags includes: self tag) not ])
			or: [ super isFiltered: aStructure ]! !

!PRTaggedPagesWidget methodsFor: 'as yet unclassified' stamp: 'kph 9/17/2007 18:10'!
items
	| items |
	items := self unfilteredItems asArray
		reject: [ :each | self isFiltered: each ].
	
	items :=  items  asSortedCollection: [ :a :b | {a priority. a title.} <= {b priority. b title. } ].
	
	self maxItems isNil
		ifFalse: [ items := items first: (items size min: self maxItems) ].
	^ items		
	
 ! !

!PRTaggedPagesWidget methodsFor: 'accessing' stamp: 'kph 9/14/2007 00:30'!
tag
	^ [ self read: #descriptionTag ] ifError: [ nil ]! !

!PRTaggedPagesWidget methodsFor: 'accessing' stamp: 'kph 9/13/2007 22:15'!
target
	^ self read: #descriptionBelow! !

!PRTaggedPagesWidget methodsFor: 'accessing' stamp: 'kph 10/21/2007 23:22'!
unfilteredItems
	| structure |
	structure :=  self target ifNil: [ self context structure ].
 
	self level isNil ifFalse: [
		^ self childrenOf: (structure parents 
			at: self level 
			ifAbsent: [ ^ #() ]) ].
	^ self childrenOf: structure.
	 ! !
